diff -Naur --exclude=CVS --exclude=configs linux/fs/umsdos/ioctl.c linux-openmosix/fs/umsdos/ioctl.c
--- linux/fs/umsdos/ioctl.c	2001-08-28 17:16:07.000000000 +0200
+++ linux-openmosix/fs/umsdos/ioctl.c	2004-02-05 10:51:23.000000000 +0100
@@ -15,6 +15,10 @@
 #include <linux/msdos_fs.h>
 #include <linux/umsdos_fs.h>
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 struct UMSDOS_DIR_ONCE {
 	struct dirent *ent;
 	int count;
@@ -209,6 +213,20 @@
 		}
 		/* update the original f_pos */
 		filp->f_pos = pos;
+#ifdef CONFIG_MOSIX_DFSA
+		{
+			struct files_struct *files = current->files;
+			register unsigned int i;
+
+			if(atomic_read(&files->count) == 1)
+			for(i = 0 ; i < files->max_fds ; i++)
+			if(files->fd[i] == filp)
+			{
+				dfsa_touch_file(i);
+				break;
+			}
+		}
+#endif /* CONFIG_MOSIX_DFSA */
 	read_dput:
 		d_drop(demd);
 		dput(demd);
diff -Naur --exclude=CVS --exclude=configs linux/hpc/badops.c linux-openmosix/hpc/badops.c
--- linux/hpc/badops.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/badops.c	2004-02-05 02:48:27.000000000 +0100
@@ -0,0 +1,228 @@
+/* Changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ * Author(s): Moshe Bar, Amnon Shiloh.
+ */
+
+#include <linux/sched.h>
+#include <linux/hpcctl.h>
+#include <linux/hpc.h>
+#include <net/tcp.h>
+#include <hpc/protocol.h>
+#include <linux/mm.h>
+#include <linux/smp_lock.h>
+#include <linux/slab.h>
+#include <linux/stddef.h>
+#include <hpc/routines.h>
+#include <hpc/defs.h>
+#include <hpc/hpcversion.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+#include <linux/fs.h>
+
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+
+static int
+bad_result(void)
+{
+	printk("%s: Tried using a DFSA 'failed_to_reopen' file -- killed!\n",
+		desc_mostask(NULL));
+	force_sig(SIGKILL, current);
+	return(-EBADF);
+}
+
+loff_t
+all_bad_llseek(struct file *f, loff_t x, int y)
+{
+	return(bad_result());
+}
+
+ssize_t
+all_bad_read(struct file *f, char *x, size_t y, loff_t *z)
+{
+	return(bad_result());
+}
+
+ssize_t
+all_bad_write(struct file *f, const char *x, size_t y, loff_t *z)
+{
+	return(bad_result());
+}
+
+unsigned int
+all_bad_poll(struct file *f, struct poll_table_struct *x)
+{
+	return(bad_result());
+}
+
+int
+all_bad_ioctl(struct inode *i, struct file *x, unsigned int y, unsigned long z)
+{
+	return(bad_result());
+}
+
+int
+all_bad_mmap(struct file *f, struct vm_area_struct *x)
+{
+	return(bad_result());
+}
+
+int
+all_bad_open(struct inode *i, struct file *x)
+{
+	return(bad_result());
+}
+
+int
+all_bad_fsync(struct file *f, struct dentry *d, int datasync)
+{
+	return(bad_result());
+}
+
+int
+all_bad_fasync(int x, struct file *f, int y)
+{
+	return(bad_result());
+}
+
+int
+all_bad_lock(struct file *f, int x, struct file_lock *y)
+{
+	return(bad_result());
+}
+
+struct file_operations all_bad_file_operations =
+{
+	.llseek = all_bad_llseek,
+	.read = all_bad_read,
+	.write = all_bad_write,
+	.poll = all_bad_poll,
+	.ioctl = all_bad_ioctl,
+	.mmap = all_bad_mmap,
+	.open = all_bad_open,
+	.fsync = all_bad_fsync,
+	.fasync = all_bad_fasync,
+	.lock = all_bad_lock
+};
+
+int
+all_bad_create(struct inode *i, struct dentry *x, int y)
+{
+	return(bad_result());
+}
+
+struct dentry *
+all_bad_lookup(struct inode *i, struct dentry *x)
+{
+	bad_result();
+	return 0;
+}
+
+int
+all_bad_link(struct dentry *d, struct inode *i, struct dentry *e)
+{
+	return(bad_result());
+}
+
+int
+all_bad_unlink(struct inode *i, struct dentry *d)
+{
+	return(bad_result());
+}
+
+int
+all_bad_symlink(struct inode *i, struct dentry *d, const char *a)
+{
+	return(bad_result());
+}
+
+int
+all_bad_follow_link(struct dentry *dp, struct nameidata *nd)
+{
+	return(bad_result());
+}
+
+int
+all_bad_get_block(struct inode *f, struct buffer_head *x, int y)
+{
+	return(bad_result());
+}
+
+int
+all_bad_readpage(struct file *f, struct page *x)
+{
+	return(bad_result());
+}
+
+int
+all_bad_writepage(struct file *f, struct page *x)
+{
+	return(bad_result());
+}
+
+int
+all_bad_bmap(struct inode *i, int x)
+{
+	return(bad_result());
+}
+
+void
+all_bad_truncate(struct inode *i)
+{
+	bad_result();
+}
+
+int
+all_bad_permission(struct inode *i, int x)
+{
+	return(bad_result());
+}
+
+int
+all_bad_smap(struct inode *i, int x)
+{
+	return(bad_result());
+}
+
+int
+all_bad_revalidate(struct dentry *d)
+{
+	return(bad_result());
+}
+
+int
+all_bad_setattr(struct dentry *d, struct iattr *attr)
+{
+	return(bad_result());
+}
+
+struct inode_operations all_bad_inode_operations = {
+        .create = all_bad_create,
+        .lookup = all_bad_lookup,
+        .link = all_bad_link,
+        .unlink = all_bad_unlink,
+        .symlink = all_bad_symlink,
+        .follow_link = all_bad_follow_link,
+        .truncate = all_bad_truncate,
+        .permission = all_bad_permission,
+        .revalidate = all_bad_revalidate,
+	.setattr = all_bad_setattr,
+};
+
+#endif /* CONFIG_MOSIX_DFSA */
+
+struct super_operations all_bad_super_operations = {
+	.alloc_inode = 0,
+	.destroy_inode = 0,
+	.read_inode = 0,
+	.write_inode = 0,
+};
+
+struct super_block bad_super_block = {
+	.s_dev = 0,
+	.s_op = &all_bad_super_operations,
+	.s_blocksize_bits = 0,
+};
